Subject: Re: New attempt to export test-lib from Git, maybe Sharness2?

From: Junio C Hamano <[email-masked]>
Date: Sat, 09 Dec 2023 10:59:00 -0800

Jiang Xin <[email-masked]> writes:

> It's not easy to upgrade sharness to the latest test framework of Git.

So?

> So I decide to start a new project. The new project is named test-lib,
> see:
>
>   * https://github.com/jiangxin/test-lib
>
> Some of my projects have upgraded the test framework from sharkness to
> test-lib:
>
>  * git-po-helper: https://github.com/git-l10n/git-po-helper/tree/main/test
>  * git-repo-go: https://github.com/alibaba/git-repo-go/tree/master/test
>
> I wonder if we can start Sharness2 based on this solution. See the
> README of the test-lib project for details:

Is it a viable option to stick to the name "test-lib" (or possibly,
"git-test-lib" to make it more prominent to say where it came from)?

If you do not plan to coordinate with those who work on (the remnant
of) the original sharness based on an ancient version of our test
framework, and do not plan to actively transition its users to your
version, it is less confusing if you named yours differently, as it
avoids hinting that your version is a successor of theirs.

I am not sure if reusing the history of our project verbatim using
filter-repo is really a good way to help those who are interested in
the test framework, by the way.  We make changes for our own purpose
and as a part of such an effort we may touch the test framework to
make it easier to test the changes we made, e.g.,

https://github.com/jiangxin/test-lib/commit/0d5db66ef2b9d8ed5bcee9a0167672dc88b1b026

and unedited filter-repo result will describe such a commit
primarily to explain why the changes in the commit was made on Git
side.  Most of the changes described in the resulting commit message
are discarded by filter-repo and the resulting history becomes hard
to follow.